
#include "init.h"
#include "global.h"
#include "toolbox.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


Config::Config()
{
   FILE *f;
   char tmp[500], tmp2[500], tmp3[500];
   int i, line=0, error=0, len;



   ax25mycall = NULL;
   ax25port = NULL;
   ax25path = NULL;
   vjboxip = NULL;
   vjboxname = NULL;
   vjboxport = 0;
	downloadmail = false;


   if ((f = fopen("vjfetch.conf", "r")) == NULL)
   {
      if ((f = fopen("/etc/vjfetch.conf", "r")) == NULL)
      {
         printf("Cannot read config-file (vjfetch.conf).\n\n");
         exit(1);
      }
   }

   while (fgets(tmp, 499, f) != NULL)
   {
   	line++;
		KillSpacesLeft(tmp);
		KillSpacesRight(tmp);
   	if ((i = POS('\n', tmp)) != -1) tmp[i] = '\0';
   	if ((i = POS('\r', tmp)) != -1) tmp[i] = '\0';

   	if (tmp[0] != '#' && tmp[0] != ';' && tmp[0] != '\0')
      {
			if ((i = POS(' ', tmp)) == -1)
         {
         	error = 1;
         	printf("Syntax error in line %i.\n", line);
         }
         else
         {
         	memcpy(tmp2, tmp, i);
            tmp2[i] = '\0';
            len = strlen(tmp)-i-1;
            memmove(tmp, tmp+i+1, len);
            tmp[len] = '\0';

            Klein(tmp2);

            if (!strcmp(tmp2, "ax25mycall"))
            	ax25mycall = (char *) strdup(tmp);
			   else
	            if (!strcmp(tmp2, "ax25port"))
	            	ax25port = (char *) strdup(tmp);
					else
		            if (!strcmp(tmp2, "ax25path"))
                  {
                  	OnlyOneSpace( tmp3, tmp );
                  	if ((i = POS(' ', tmp3)) == -1)
                     {
                     	ax25path = NULL;
		            		ax25call = (char *) strdup(tmp3);
                     }
                     else
                     {
                     	memcpy( tmp, tmp3, i );
                        tmp[i] = '\0';
                        ax25call = (char *) strdup(tmp);
                        len = strlen(tmp3)-i-1;
                        memcpy( tmp3, tmp3+i+1, len );
                        tmp3[len] = '\0';
                        ax25path = (char *) strdup(tmp3);
                     }
						}
						else
			            if (!strcmp(tmp2, "vjboxip"))
			            	vjboxip = (char *) strdup(tmp);
							else
				            if (!strcmp(tmp2, "vjboxname"))
				            	vjboxname = (char *) strdup(tmp);
								else
					            if (!strcmp(tmp2, "vjboxport"))
					            	vjboxport = atoi(tmp);
									else
										if (!strcmp(tmp2, "downloadmail"))
	                           {
                                 if (tmp[0] == '1')
                                    downloadmail = true;
                                 else
                                 	if (tmp[0] == '0')
                                    	downloadmail = false;
                                    else
                                    {
									         	error = 1;
									         	printf("Syntax error in line %i.\n", line);
												}
	                           }
			   						else
		                        {
							         	error = 1;
							         	printf("Syntax error in line %i.\n", line);
										}
      	}
		}
	}

   fclose(f);

   if (ax25mycall == NULL)
   {
   	error = 1;
   	printf("Error: ax25mycall-Line misssing.\n");
	}
   if (ax25call == NULL)
   {
   	error = 1;
   	printf("Error: ax25port-Line misssing.\n");
	}
   if (ax25path == NULL)
   {
   	error = 1;
   	printf("Error: ax25path-Line misssing.\n");
	}
   if (vjboxip == NULL)
   {
   	error = 1;
   	printf("Error: vjboxip-Line misssing.\n");
	}
   if (vjboxname == NULL)
   {
   	error = 1;
   	printf("Error: vjboxname-Line misssing.\n");
	}
   if (vjboxport == 0)
   {
   	error = 1;
   	printf("Error: vjboxport-Line misssing.\n");
	}

	if (error)
   {
   	printf("\n");
   	exit(1);
   }
}


Config::~Config()
{
}

